<?php
// API doc : http://techbureau-api-document.readthedocs.io/ja/latest/public/2_individual/1_currencies.html
// API url : https://api.zaif.jp/api/1/currencies/{currency}

// currencies api url
$zaif_api_url  = "https://api.zaif.jp/api/1/currencies/";

// proxy settings
$proxy      = "";
$proxy_port = "";

$curl = curl_init();
if ($curl == FALSE) {
    fputs(STDERR, "[ERR] curl_init(): " . curl_error($curl) . PHP_EOL);
    die(1);
}

// curl set options
$currency = "all";  // all currencies
curl_setopt($curl, CURLOPT_URL, $zaif_api_url . $currency);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
// set proxy server settings
if (!empty($proxy) && !empty($proxy_port)) {
    curl_setopt($curl, CURLOPT_HTTPPROXYTUNNEL, 1);
    curl_setopt($curl, CURLOPT_PROXY, $proxy . ":" . $proxy_port);
    curl_setopt($curl, CURLOPT_PROXYPORT, $proxy_port);
}

// call currencies api
$response = curl_exec($curl);
if ($response == FALSE) {
    fputs(STDERR, "[ERR] curl_exec(): " . curl_error($curl) . PHP_EOL);
    die(1);
}
// json decode
$json_decode = json_decode($response, true);
if ($json_decode == NULL) {
    fputs(STDERR, "[ERR] json_decode(): " . json_last_error_msg() . PHP_EOL);
    die(1);
}
curl_close($curl);

// show currencies
//print_r($json_decode);

// sort by id
foreach ($json_decode as $key => $value){
  $key_id[$key] = $value['id'];
}
array_multisort ($key_id , SORT_ASC , $json_decode);
// show currencies
printf("id\tname\t\tis_token" . PHP_EOL);
print ("---------------------------------" . PHP_EOL);
foreach ($json_decode as $cur) {
    $is_token = "";
    if ($cur["is_token"]) { $is_token = "Y"; }
    $cur_name = $cur["name"];
    if (strlen($cur["name"]) < 8) { $cur_name = $cur_name . "\t"; }
    printf("%d\t%s\t\t%s" . PHP_EOL, $cur["id"], $cur_name, $is_token);
}

exit(0);
